// Id 280,288,488,380,320,520,420

#include <CAN.h>

unsigned long currentMillis = 0;
unsigned long previousMillis = 0;
const long intervalRashod = 1000;
const float coefficentRashod = 0.9;
      int previousDataRashodLH = 0; //для вычисления расхода
      int currentDataRashodLH = 0; //для вычисления расхода
      int raznica = 0;      //для вычисления расхода
float rashodLH;             // расход литров в час
float rashodL100current;    // расход литров на 100 текущий
unsigned long time;         // время для подсчета среднего расхода
float fuel, rashodL100AVG;  // средний расход
float potrFuel;             // потрачение топливо
float odo; // пробег за поездку
float zapasHoda;

int8_t coolant;    // температура двигателя
uint8_t speed;     // скорость по эбу
uint8_t fuelLevel; // уровень топлива
int16_t RPM;       // обороты
int16_t odometr;   // одометр

int torqueMoment; // крутящий момент
int temp; // температура за бортом
int oilTemp; // температура масла
int LightDash; // уровень подсветки
int pedalGas; // Нажатие на педаль газа
int air; // температура на впуске
bool cruise;       // круиз контроль
bool handBrake;    // ручник
bool antifrizeLow; // датчик уровня антифриза



void setup()
{
  Serial.begin(9600);
  while (!Serial);
  Serial.println("CAN Receiver");
  CAN.setClockFrequency(8e6);

  // start the CAN bus at 500 kbps
  if (!CAN.begin(500E3))
  {
    Serial.println("Starting CAN failed!");
    while (1);
  }
}

void loop()
{
  // Чтение сообщений из CAN шины
  if (CAN.parsePacket())
  {
    // Чтение идентификатора сообщения
    uint32_t canId = CAN.packetId();

    // Чтение данных из сообщения CAN (данные могут быть разной длины)
    uint8_t len = CAN.packetDlc();
    uint8_t data[8];
    for (uint8_t i = 0; i < len; i++)
    {
      data[i] = CAN.read();
      
    }

    if (canId != 648 and canId != 800 and canId != 640 and canId != 1312 and canId != 896 and canId != 1160 and canId != 904 and canId != 1056 and canId != 1152)
    {
      Serial.println(canId);
    }
    // hex 1312-520,648-288,800-320,640-280,896-380,1160-488,904-388,1056-420,1152-480
    //    1  640 -2 и 1


    switch (canId)
    {
    case 1056:
      //Serial.println(data[3] - 60);
      temp = (data[2] - 100) / 2;
      oilTemp = data[3] - 60;
      LightDash = data[5];
      break;
    case 896:
      air = data[1] * 0.75 - 48;
      pedalGas = data[2];
      break;
    case 648:
      coolant = data[1] * 0.75 - 48;
      speed = data[3] / 0.72;
      cruise = data[2];
      break;
    case 640:
      RPM = (data[3] * 256 + data[4]) / 4;
      
      torqueMoment = data[1] * 2;
      break;
    case 1152:
    // Serial.println(data[3]);
                                          currentMillis = millis();
                                          if(currentMillis - previousMillis >= intervalRashod){
                                            float timeInterval = (currentMillis - previousMillis)/1000;
                                            //Serial.println(timeInterval);
                                            time++;
                                            previousMillis = currentMillis;
                                            currentDataRashodLH = data[3];

                                            if(currentDataRashodLH<previousDataRashodLH){

                                              rashodLH = (currentDataRashodLH+raznica-127)*coefficentRashod/timeInterval;
                                            } else {
                                              rashodLH = (currentDataRashodLH-previousDataRashodLH)*coefficentRashod/timeInterval;
                                            }

                                            previousDataRashodLH = currentDataRashodLH;
                                            raznica = 255-currentDataRashodLH;
                                          
                                          if(speed > 0 ){
                                            rashodL100current = rashodLH/speed*60;
                                            fuel = fuel + rashodL100current;
                                          } else {

                                          }
                                          rashodL100AVG = fuel/timeInterval;
                                          potrFuel = potrFuel + rashodLH/3600;
                                          odo = odo+speed/3600;
                                          zapasHoda = fuelLevel/rashodL100AVG*100;
                                          }
        Serial.println((String)rashodLH+"/potr: "+potrFuel+"/zapas: "+zapasHoda+"/sr: "+rashodL100AVG);
      break;
    case 800:
       //Serial.println(bitRead(data[1], 1));     // Ручник
      //  Serial.println(bitRead(data[1], 2));     // Ручник
// в 5 левый поворот 16 правый поворот 32 аварийка 48
// 0 -4 завел двигатель
      // Serial.print("0: ");
      //  Serial.print(data[0]);     // Дверь водителя
      // Serial.print(" 1: ");
      //  Serial.print(data[1]);     // Дверь водителя
      //  Serial.print(" 2: ");
      //  Serial.print(data[2]);     // Дверь водителя
      //  Serial.print(" 3: ");
      //  Serial.print(data[3]);     // Дверь водителя
      //  Serial.print(" 4: ");
      //  Serial.print(data[4]);     // Дверь водителя
      //  Serial.print(" 5: ");
      //  Serial.print(data[5]);     // Дверь водителя
      //  Serial.print(" 6: ");
      //  Serial.print(data[6]);     // Дверь водителя
      //  Serial.print(" 7: ");
      //  Serial.print(data[7]);     // Дверь водителя
      //  Serial.print(" 8: ");
      //  Serial.println(data[8]);     // Дверь водителя
      
      //  Serial.println("1:"+bitRead(data[1], 1));     // Дверь водителя
      //  Serial.println("2:"+bitRead(data[1], 2));     // Дверь водителя
      //  Serial.println("3:"+bitRead(data[1], 3));     // Дверь водителя
      //  Serial.println("4:"+bitRead(data[1], 4));     // Дверь водителя
      //  Serial.println("5:"+bitRead(data[1], 5));     // Дверь водителя
      //  Serial.println("6:"+bitRead(data[1], 6));     // Дверь водителя
      //  Serial.println("7:"+bitRead(data[1], 7));     // Дверь водителя
      //  Serial.println("8:"+bitRead(data[1], 8));     // Дверь водителя
      //  Serial.println("1:"+bitRead(data[2], 1));     // Дверь водителя
      //  Serial.println("2:"+bitRead(data[2], 2));     // Дверь водителя
      //  Serial.println("3:"+bitRead(data[2], 3));     // Дверь водителя
      //  Serial.println("4:"+bitRead(data[2], 4));     // Дверь водителя
      //  Serial.println("5:"+bitRead(data[2], 5));     // Дверь водителя
      //  Serial.println("6:"+bitRead(data[2], 6));     // Дверь водителя
      //  Serial.println("7:"+bitRead(data[2], 7));     // Дверь водителя
      //  Serial.println("8:"+bitRead(data[2], 8));     // Дверь водителя
      //  Serial.println("1:"+bitRead(data[3], 1));     // Дверь водителя
      //  Serial.println("2:"+bitRead(data[3], 2));     // Дверь водителя
      //  Serial.println("3:"+bitRead(data[3], 3));     // Дверь водителя
      //  Serial.println("4:"+bitRead(data[3], 4));     // Дверь водителя
      //  Serial.println("5:"+bitRead(data[3], 5));     // Дверь водителя
      //  Serial.println("6:"+bitRead(data[3], 6));     // Дверь водителя
      //  Serial.println("7:"+bitRead(data[3], 7));     // Дверь водителя
      //  Serial.println("8:"+bitRead(data[3], 8));     // Дверь водителя
      //  Serial.println("1:"+bitRead(data[4], 1));     // Дверь водителя
      //  Serial.println("2:"+bitRead(data[4], 2));     // Дверь водителя
      //  Serial.println("3:"+bitRead(data[4], 3));     // Дверь водителя
      //  Serial.println("4:"+bitRead(data[4], 4));     // Дверь водителя
      //  Serial.println("5:"+bitRead(data[4], 5));     // Дверь водителя
      //  Serial.println("6:"+bitRead(data[4], 6));     // Дверь водителя
      //  Serial.println("7:"+bitRead(data[4], 7));     // Дверь водителя
      //  Serial.println("8:"+bitRead(data[4], 8));     // Дверь водителя
      //  Serial.println("1:"+bitRead(data[5], 1));     // Дверь водителя
      //  Serial.println("2:"+bitRead(data[5], 2));     // Дверь водителя
      //  Serial.println("3:"+bitRead(data[5], 3));     // Дверь водителя
      //  Serial.println("4:"+bitRead(data[5], 4));     // Дверь водителя
      //  Serial.println("5:"+bitRead(data[5], 5));     // Дверь водителя
      //  Serial.println("6:"+bitRead(data[5], 6));     // Дверь водителя
      //  Serial.println("7:"+bitRead(data[5], 7));     // Дверь водителя
      //  Serial.println("8:"+bitRead(data[5], 8));     // Дверь водителя
      handBrake = bitRead(data[1], 1);
      //  Serial.print("Ручник: ");
      //  Serial.println(handBrake);     // Ручник

      fuelLevel = data[2];
      // Serial.print("Уровень топлива: ");
      // Serial.print(fuelLevel);
      // Serial.println(" л.");

      antifrizeLow = bitRead(data[0], 4);
      //   Serial.println(bitRead(data[5], 4));     // левый поворот
      //   Serial.println(bitRead(data[5], 5));     // правый поворот
      //   Serial.println(bitRead(data[1], 8));     // Ошибка тормозов
      //   Serial.println(bitRead(data[0], 3));     // Низкое давление масла
      //  Serial.println(bitRead(data[0], 4));     // Низкий уровень антифриза
      break;
    default:
      // выполнить, если значение не совпадает ни с одним из case
      break;
    }
     //Serial.println("Обороты:"+(String)RPM+" TEMP:"+coolant+" FuLev:"+fuelLevel+" Brake:"+handBrake+" Speed:"+speed+" Cruise:"+cruise+ " Расход:"+rashodLH+"l/h");
  }
}
